# Tag 
tag @a remove can_fly
tag @a[hasitem={item=cubed:chicken_bow,location=slot.weapon.mainhand}] add can_fly
title @a[tag=can_fly, tag=!taken_off] actionbar Double jump to start flying

# Give slow_falling to dragons
scoreboard objectives add slow_falling dummy
scoreboard players add @a slow_falling 1
scoreboard players set @a[scores={slow_falling=3}] slow_falling 0
effect @a[tag=can_fly, scores={slow_falling=1..}, tag=slow_falling] slow_falling 1 1 true
effect @a[tag=can_fly, scores={slow_falling=0}, tag=slow_falling] slow_falling 0 1 true

# Reset players
# effect @a[tag=!can_fly] speed 0 2 true
event entity @a[tag=!can_fly] cubed:gravity

# Ascend dragons
# Stay on ground
tag @a[tag=can_fly, tag=on_ground] remove taken_off
tag @a[tag=can_fly, tag=on_ground] remove slow_falling
execute as @a[tag=can_fly, tag=taken_off] at @s unless block ~~-0.5~ air unless entity @s[rxm=-90,rx=-10] unless entity @s[scores={jump_start=1..}, rxm=-90,rx=15] run tag @s remove taken_off

# Take off with double_jump
scoreboard objectives add jump dummy
scoreboard players add @a jump 0
scoreboard players add @a[scores={jump=1..}] jump -1
scoreboard objectives add jump_start dummy
scoreboard players add @a jump_start 0
scoreboard players add @a[scores={jump_start=1..}] jump_start -1
execute as @a[tag=can_fly] at @s[scores={jump=25..}] run function fly/double_jump

# Set on_ground
event entity @a[tag=can_fly, tag=taken_off] cubed:taken_off
event entity @a[tag=can_fly, tag=!taken_off] cubed:not_taken_off

# Give flying dragons speed
# effect @a[tag=can_fly, tag=taken_off] speed 15000 3 true
# effect @a[tag=can_fly, tag=!taken_off] speed 0 2 true
effect @a[tag=can_fly, tag=!taken_off] slow_falling 0 2 true
effect @a[tag=can_fly, tag=!taken_off] levitation 0 2 true
event entity @a[tag=can_fly, tag=!taken_off] cubed:gravity
tag @a[m=creative] remove taken_off

# Tp with delay to fix the ascenscion / descension bug
scoreboard objectives add tp_delay dummy
scoreboard players add @a[scores={tp_delay=1..}] tp_delay -1
execute as @a[tag=can_fly, scores={tp_delay=1}] at @s run tp @s ~~~